
// DECLARATIONS FOR THIS CLASS ARE STORED IN MSGCLS.H, THIS HEADER FILE
// MUST FOLLOW IT IN YOUR SOURCE CODE.
//

#define string1 "being sent to BSreal class"

#define CR "\r\n"
#define LINE cout << CR; for(i=0;i<80;i++) putch('-');
#define bsreal bassngl
#define ulong unsigned long

#ifndef BSREAL_CLASS
#define BSREAL_CLASS

//===================[ BSreal CLASS DEFINITION ]===============
//
class BSreal {
        ulong           long_val;
        double          double_val;
        bassngl         bsreal_val;

public:
        BSreal(double);
        BSreal(bassngl);
        void operator ++ (void);        // Increment current value in object
        void operator -- (void);        // Decrement current value in object
        void copy_BSreal_to(bassngl);   // Copy bsreal to new dest
        ulong get_long_value(void);     // return current long value in object
        void dump(char *str);           // for debugging purposes (dumps object to screen)
};


#endif

