// CLASS TO MANAGE CNAMES.@@@

#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <fcntl.h>
#include <io.h>
#include <string.h>
#include "msgcls.h"
#include "cnmcls.h"


CONFDATA::CONFDATA(char *fn){
        fhandle=recsize=0;
        memset(filename,'\0',34);
        memmove(filename,fn,strlen(fn));
        if((fhandle=open(filename,O_RDONLY|O_BINARY|O_DENYNONE))==-1){
                cout << CR"Attempted to open " << filename << CR;
                perror(CR"Error encountered reading file:");
                exit(1);}
        if((read(fhandle,&recsize,sizeof(int)))==-1){
                cout << CR"Error encountered trying to read in record size"CR;
                exit(1);}
}

CONFDATA::~CONFDATA(){
        if(fhandle!=0)
                close(fhandle);
}

void CONFDATA::get_conf_data(ulong conf){
        if((lseek(fhandle,conf*recsize+sizeof(int),SEEK_SET))==-1){
                cout << CR"Error encountered trying to locate conference (" << conf <<")";
                cout << "data in " << filename << ".";
                exit(1);}
        if((read(fhandle,&cnames,recsize))!=recsize){
                cout << CR"Error encountered reading in data for conference #" << conf;
                exit(1);}
}

char* CONFDATA::get_msg_file(){
        static char msgs_file[33];
        memset(msgs_file,'\0',33);
        memmove(msgs_file,cnames.msgfile,32);
        return (msgs_file);
}

char* CONFDATA::get_conf_name(){
        static char confname[15];
        memset(confname,'\0',15);
        memmove(confname,cnames.name,14);
        return(confname);
}

char* CONFDATA::get_uplddir(){
        static char updir[29];
        memset(updir,'\0',29);
        memmove(updir,cnames.uplddir,29);
        return(updir);
}


char* CONFDATA::get_pubuplodloc(){
        static char uploc[26];
        memset(uploc,'\0',26);
        memmove(uploc,cnames.pubuplodloc,26);
        return(uploc);
}
