.AUTODEPEND

#		*Translator Definitions*
CC = tcc +MSGS.CFG
TASM = TASM
TLINK = tlink


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

.asm.obj:
  $(TASM) {$< }


#		*List Macros*


EXE_dependencies =  \
  msgs.obj \
  tools.obj \
  msgicls.obj \
  bsreal.obj \
  msgcls.obj \
  msgidx.obj \
  cnmcls.obj \
  ..\mylib\rlcvt_m.lib

#		*Explicit Rules*
msgs.exe: msgs.cfg $(EXE_dependencies)
  $(TLINK) /v/x/c @&&|
d:\tc\lib\c0m.obj+
msgs.obj+
tools.obj+
msgicls.obj+
bsreal.obj+
msgcls.obj+
msgidx.obj+
cnmcls.obj
msgs,
..\mylib\rlcvt_m.lib+
d:\tc\lib\graphics.lib+
d:\tc\lib\emu.lib+
d:\tc\lib\mathm.lib+
d:\tc\lib\cm.lib
|


#		*Individual File Dependencies*
msgs.obj: msgs.cpp 

tools.obj: tools.cpp 

msgicls.obj: msgicls.cpp 

bsreal.obj: bsreal.cpp 

msgcls.obj: msgcls.cpp 

msgidx.obj: msgidx.cpp 

cnmcls.obj: cnmcls.cpp 

#		*Compiler Configuration File*
msgs.cfg: msgs.mak
  copy &&|
-mm
-C
-N
-v
-G
-O
-Z
-V
-vi-
-P
-wdef
-ID:\TC\INCLUDE;D:\TC\MYINCLUD
-LD:\TC\LIB;D:\TC\MYLIB
-g5
| msgs.cfg


