#include <sys\stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include <process.h>
#include <fcntl.h>
#include <iostream.h>
#include <io.h>

#include "msgcls.h"
#include "bsreal.h"
#include "cnmcls.h"
#include "tools.h"


// Set pointer to point to data after switch
//
#define set_charptr(x)	{ptr=strstr(args[i],":");ptr++; x=*ptr;}
#define set_longptr(x)  {ptr=strstr(args[i],":");ptr++; x=(unsigned long)atol(ptr);}
#define set_strptr(x)  {ptr=strstr(args[i],":");ptr++; memcpy(x,ptr,strlen(ptr));}
#define compare(x) 	if((strncmp(args[i],x,strlen(x)))==0)

#define TO << CR <<


// THIS INFO STORED IN TOOLS.CPP
//
extern char cn[80];    // CNAMES.@@@ LOCATION
extern int NWF;        // Multi-node flag (default is single node);


// GLOBAL VARIABLES FOR MESSAGE BASE
//
char 	STATUS=' ';
ulong 	CONFERENCE=0;
char 	MSGFROM[25],
		MSGTO[25],
		MSGSUBJECT[25],
		DISKFILE[80];


// THIS IS SHOWN FOR MSG ?
//
void show_instructions(){
	char *str=
	CR"  Usage: PCBMSG [/X:XX] [/X:XX] [...]"
	CR"Purpose: Update message base from DOS text file."CR
	CR"/D:filename .......... Filename with message text."
	CR"/M:message subject ... Subject for message."
	CR"/F:message from ...... Who message is from."
	CR"/T:message to ........ Who message is to."
	CR"/C:conference ........ Conference to place mail in."
	CR"/S:Message status .... Message status (see note)."
	CR"/N ................... Multi-Node flag."CR

	CR"NOTE: No status will default to public message. Available status codes follow:"CR
	CR"  * = Private message   ~ = Comment to SYSOP "CR;
	cout << str;
	exit(1);
}


void setup_message(IMBH& message){
	int in;
	cout << CR"Creating message ";
	memset(&message,' ',sizeof(IMsgBaseHdr));
	message.set_msg_status(STATUS);		// Private message
	message.set_entry_date(datestr());	// get and set date MM-DD-YY format
	message.set_entry_time(timestr());  // get and set time HH:MM format
	message.set_msg_to(MSGTO);          // set message to field.
	message.set_msg_from(MSGFROM);      // set message from field.
	message.set_msg_subject(MSGSUBJECT);// set message subject.
	message.set_active_status(225);// 225 = active
	cout << "from " << trim(MSGFROM) << " to " << trim(MSGTO);
	if((in=open(DISKFILE,O_RDONLY|O_DENYNONE|O_BINARY))==-1){
		cout TO "Error encountered trying to read " << DISKFILE << "!!";
		cout TO "Message aborted...";
		exit(1);
	}
	unsigned long fsize=filelength(in);
	char *filetext=(char*)malloc(fsize+1);
	memset(filetext,'\0',fsize+1);
	if(filetext==NULL){
		cout TO "Error encountered trying to allocate memory for message text";
		cout TO "Process aborted...";
		exit(1);
	}
	if((read(in,filetext,fsize))!=fsize){
		cout TO "Error encountered reading in message text!!";
		cout TO "Process aborted...";
		free(filetext);
		exit(1);
	}
	close(in);

	// NOTE: IMBHdata.num_blks is set by the following function.
	//
	message.IBM_to_PCB(filetext);	// Convert string to PCB format

	free(filetext);                 // Free memory for filetext

}

void parse_args(int arg,char *args[]){
	char *ptr;
	for (int i=1;i<arg;i++){
		compare("/D:")	set_strptr(DISKFILE);
		compare("/M:")	set_strptr(MSGSUBJECT);
		compare("/F:") 	set_strptr(MSGFROM);
		compare("/T:") 	set_strptr(MSGTO);
		compare("/C:")	set_longptr(CONFERENCE);
		compare("/N")	NWF=1;
		compare("/S:")	set_charptr(STATUS);
	}
}

main(int argc, char *argv[]){
	clrscr();

	if((strcmp(argv[1],"?"))==0) show_instructions();
	parse_args(argc,argv);
	if(argc<2) show_instructions();

	strcpy(cn,get_pcboard_dat(31));     // Line 31 is CALLER location.
	strcat(cn,".@@@");                  // We are setting up global variable.

	IMBH message;                       // Class that will read in the message
	setup_message(message);				// Fill in the object with data.

	append_message(message,CONFERENCE);	// Append the object to conference 'confnmbr'

}
